Input Method (GUI)(3m17n)

NAME
m17nInputMethodWin - Input Method (GUI): Input method support on window systems.

  Data Structures
struct MInputGUIArgIC
Type of the argument to the function minput_create_ic().
struct MInputXIMArgIM
Structure pointed to by the argument arg of the function minput_open_im().
struct MInputXIMArgIC
Structure pointed to by the argument arg of the function minput_create_ic().

  Functions
MSymbol minput_event_to_key (MFrame *frame, void *event)
Convert an event to an input key.

  Variables
MInputDriver minput_gui_driver
Input driver for internal input methods on window systems.
MSymbol Mxim
Symbol of the name 'xim'.
MInputDriver minput_xim_driver

Detailed Description

Input method support on window systems.

Input method driver for XIM.

The input driver minput_gui_driver is provided for internal input methods that is useful on window systems. It displays preedit text and status text at the inputting spot. See the documentation of minput_gui_driver for more details.

In the m17n-X library, the foreign input method of name Mxim is provided. It uses XIM (X Input Method) as a background input engine. The symbol Mxim has a property Minput_driver whose value is a pointer to the input driver minput_xim_driver. See the documentation of minput_xim_driver for more details.

The driver minput_xim_driver is for the foreign input method of name Mxim. It uses XIM (X Input Methods) as a background input engine.

As the symbol Mxim has property Minput_driver whose value is a pointer to this driver, the input method of language Mnil and name Mxim uses this driver.

Therefore, for such input methods, the driver dependent arguments to the functions whose name begin with minput_ must be as follows.

The argument arg of the function minput_open_im() must be a pointer to the structure MInputXIMArgIM. See the documentation of MInputXIMArgIM for more details.

The argument arg of the function minput_create_ic() must be a pointer to the structure MInputXIMArgIC. See the documentation of MInputXIMArgIC for more details.

The argument arg of the function minput_filter() must be a pointer to the structure XEvent. The argument key is ignored.

The argument arg of the function minput_lookup() must be the same one as that of the function minput_filter(). The argument key is ignored.

Data Structure Documentation

  MInputGUIArgIC

Type of the argument to the function minput_create_ic().

FIELD DOCUMENTATION:

MFrame* MInputGUIArgIC::frame

Frame of the client.

MDrawWindow MInputGUIArgIC::client

Window on which to display the preedit and status text.

MDrawWindow MInputGUIArgIC::focus

Window that the input context has a focus on.

  MInputXIMArgIM

Structure pointed to by the argument arg of the function minput_open_im().

FIELD DOCUMENTATION:

Display* MInputXIMArgIM::display

The meaning of the following four members are the same as arguments to XOpenIM(). Display of the client.

XrmDatabase MInputXIMArgIM::db

Pointer to the X resource database.

char* MInputXIMArgIM::res_class

Full class name of the application.

char* MInputXIMArgIM::res_name

Full resource name of the application.

char* MInputXIMArgIM::locale

Locale name under which an XIM is opened.

char* MInputXIMArgIM::modifier_list

Arguments to XSetLocaleModifiers().

  MInputXIMArgIC

Structure pointed to by the argument arg of the function minput_create_ic().

FIELD DOCUMENTATION:

XIMStyle MInputXIMArgIC::input_style

Used as the arguments of XCreateIC following XNInputStyle. If this is zero, ( XIMPreeditNothing | XIMStatusNothing) is used, and <preedit_attrs> and <status_attrs> are set to NULL.

Window MInputXIMArgIC::client_win

Used as the argument of XCreateIC following XNClientWindow.

Window MInputXIMArgIC::focus_win

Used as the argument of XCreateIC following XNFocusWindow.

XVaNestedList MInputXIMArgIC::preedit_attrs

If non- NULL, used as the argument of XCreateIC following XNPreeditAttributes.

XVaNestedList MInputXIMArgIC::status_attrs

If non- NULL, used as the argument of XCreateIC following XNStatusAttributes.

Variable Documentation

  MInputDriver minput_gui_driver

Input driver for internal input methods on window systems.

The input driver minput_gui_driver is for internal input methods to be used on window systems.

It creates sub-windows for a preedit text and a status text, and displays them at the input spot set by the function minput_set_spot().

The macro M17N_INIT() set the variable minput_driver to the pointer to this driver so that all internal input methods use it.

Therefore, unless minput_driver is changed from the default, the driver dependent arguments to the functions whose name begin with minput_ must are treated as follows.

The argument arg of the function minput_open_im() is ignored.

The argument arg of the function minput_create_ic() must be a pointer to the structure MInputGUIArgIC. See the documentation of MInputGUIArgIC for more details.

If the argument key of function minput_filter() is Mnil, the argument arg must be a pointer to the object of type XEvent. In that case, key is generated from arg.

The argument arg of the function minput_lookup() must be the same one as that of the function minput_filter().

  MInputDriver minput_xim_driver

Initial value:

  { xim_open_im, xim_close_im, xim_create_ic, xim_destroy_ic,
    xim_filter, xim_lookup, NULL }

  MSymbol Mxim

Symbol of the name 'xim'.

The variable Mxim is a symbol of name 'xim'. It is a name of the input method driver minput_xim_driver.

COPYRIGHT
Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2008 National Institute of Advanced Industrial Science and Technology (AIST)
Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License <http://www.gnu.org/licenses/fdl.html>.